
/*  A Bison parser, made from parser.yy
 by  GNU Bison version 1.26
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	INTEGER	257
#define	STRING	258
#define	TAG	259
#define	REVNUM	260
#define	ID_CHAR	261
#define	ID_DESCRIPTION	262
#define	ID_TOTREVISIONS	263
#define	ID_SELREVISIONS	264
#define	ID_KEYWORD	265
#define	ID_SYMBOLIC	266
#define	ID_ACCESS	267
#define	ID_LOCKS	268
#define	ID_STRICT	269
#define	ID_BRANCH	270
#define	ID_HEAD	271
#define	ID_WORKING	272
#define	ID_RCS	273
#define	ID_REVISION	274
#define	ID_DATE	275
#define	ID_BRANCHES	276
#define	ID_REVFOLLOW	277
#define	ID_ENDFOLLOW	278
#define	ID_LINES	279
#define	ID_ANYBUTSEP	280
#define	ID_LOCKEDBY	281
#define	ID_AUTHOR	282
#define	ID_STATE	283

#line 1 "parser.yy"

/*
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 1, or (at your option)
** any later version.

** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.

** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include "common.h"

#if qCvsDebug
#	define YYDEBUG 1
#else
#	define YYDEBUG 0
#endif

static void expect(kTokens type);

static int sInt;
static CLogStr sStr;
static CRevNumber sRev;

#line 37 "parser.yy"
typedef union {
	char *string;
	int aint;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		148
#define	YYFLAG		-32768
#define	YYNTBASE	33

#define YYTRANSLATE(x) ((unsigned)(x) <= 283 ? yytranslate[x] : 94)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,    31,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    30,    32,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     6,     8,     9,    13,    15,    16,    20,
    21,    25,    26,    29,    31,    33,    35,    37,    39,    41,
    43,    45,    47,    49,    50,    53,    54,    56,    58,    59,
    64,    65,    68,    69,    71,    73,    74,    77,    78,    82,
    83,    84,    85,    86,    87,    88,    89,   110,   111,   116,
   121,   126,   131,   132,   133,   140,   141,   144,   145,   148,
   150,   152,   154,   155,   156,   163,   164,   165,   171,   172,
   177,   181,   182,   185,   186,   191,   195,   196,   199,   200,
   205,   207,   208,   213,   214,   220,   221,   224,   225,   230,
   231,   236,   237,   242,   243,   248,   249
};

static const short yyrhs[] = {    34,
     0,     0,    34,    35,     0,    39,     0,     0,    23,    36,
    47,     0,    24,     0,     0,     1,    37,    41,     0,     0,
    63,    38,    41,     0,     0,    39,    40,     0,    92,     0,
    90,     0,    88,     0,    86,     0,    80,     0,    76,     0,
    72,     0,    70,     0,    65,     0,    43,     0,     0,    41,
    42,     0,     0,     7,     0,     4,     0,     0,     8,    30,
    44,    45,     0,     0,    45,    46,     0,     0,     7,     0,
     4,     0,     0,    47,    48,     0,     0,    20,    49,     6,
     0,     0,     0,     0,     0,     0,     0,     0,    21,    30,
    50,    64,    31,    51,    64,    31,    52,    64,    53,    64,
    30,    54,    64,    30,    55,    64,    56,    32,     0,     0,
    22,    30,    57,    60,     0,    28,    30,    63,    32,     0,
    27,    30,    63,    32,     0,    29,    30,    63,    32,     0,
     0,     0,    25,    30,    58,    64,    59,    64,     0,     0,
    60,    61,     0,     0,     6,    32,     0,     4,     0,     5,
     0,     3,     0,     0,     0,     9,    30,    66,    64,    67,
    68,     0,     0,     0,    32,    10,    30,    69,    64,     0,
     0,    11,    30,    71,    62,     0,    12,    30,    73,     0,
     0,    73,    74,     0,     0,    63,    30,    75,     6,     0,
    13,    30,    77,     0,     0,    77,    78,     0,     0,    63,
    30,    79,    63,     0,    63,     0,     0,    14,    30,    81,
    83,     0,     0,    14,    30,    15,    82,    83,     0,     0,
    83,    84,     0,     0,    63,    30,    85,     6,     0,     0,
    16,    30,    87,     6,     0,     0,    17,    30,    89,     6,
     0,     0,    18,    30,    91,    62,     0,     0,    19,    30,
    93,    62,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    75,    78,    80,    83,    85,    93,    93,    94,   104,   104,
   112,   114,   115,   118,   120,   121,   122,   123,   124,   125,
   126,   127,   128,   131,   133,   136,   138,   145,   154,   157,
   159,   161,   164,   166,   171,   178,   179,   182,   184,   191,
   192,   198,   204,   210,   216,   222,   230,   230,   232,   232,
   239,   246,   253,   254,   261,   269,   271,   274,   276,   287,
   291,   295,   299,   301,   308,   310,   312,   313,   320,   322,
   330,   334,   336,   339,   349,   359,   363,   365,   368,   378,
   378,   388,   396,   396,   403,   405,   407,   410,   420,   430,
   432,   441,   443,   452,   454,   462,   464
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","INTEGER",
"STRING","TAG","REVNUM","ID_CHAR","ID_DESCRIPTION","ID_TOTREVISIONS","ID_SELREVISIONS",
"ID_KEYWORD","ID_SYMBOLIC","ID_ACCESS","ID_LOCKS","ID_STRICT","ID_BRANCH","ID_HEAD",
"ID_WORKING","ID_RCS","ID_REVISION","ID_DATE","ID_BRANCHES","ID_REVFOLLOW","ID_ENDFOLLOW",
"ID_LINES","ID_ANYBUTSEP","ID_LOCKEDBY","ID_AUTHOR","ID_STATE","':'","'/'","';'",
"cvslog","allDeclarations","allDeclaration","@1","@2","@3","rcsDeclarations",
"rcsDeclaration","anyDeclarations","anyDeclaration","descDeclaration","@4","descListDeclarations",
"descListDeclaration","allrevDeclarations","allrevDeclaration","@5","@6","@7",
"@8","@9","@10","@11","@12","@13","@14","@15","revnumListDeclarations","revnumListDeclaration",
"stringDeclaration","tagDeclaration","intDeclaration","totRevDeclaration","@16",
"@17","selRevDeclaration","@18","keywordDeclaration","@19","symbolicNamesDeclaration",
"symbolicListDeclarations","symbolicListDeclaration","@20","accessDeclaration",
"accessListDeclarations","accessListDeclaration","@21","locksDeclaration","@22",
"@23","locksListDeclarations","locksListDeclaration","@24","branchRevDeclaration",
"@25","headRevDeclaration","@26","workingFileDeclaration","@27","rcsFileDeclaration",
"@28", NULL
};
#endif

static const short yyr1[] = {     0,
    33,    34,    34,    35,    36,    35,    35,    37,    35,    38,
    35,    39,    39,    40,    40,    40,    40,    40,    40,    40,
    40,    40,    40,    41,    41,    42,    42,    42,    44,    43,
    45,    45,    46,    46,    46,    47,    47,    49,    48,    50,
    51,    52,    53,    54,    55,    56,    48,    57,    48,    48,
    48,    48,    58,    59,    48,    60,    60,    61,    61,    62,
    63,    64,    66,    67,    65,    68,    69,    68,    71,    70,
    72,    73,    73,    75,    74,    76,    77,    77,    79,    78,
    78,    81,    80,    82,    80,    83,    83,    85,    84,    87,
    86,    89,    88,    91,    90,    93,    92
};

static const short yyr2[] = {     0,
     1,     0,     2,     1,     0,     3,     1,     0,     3,     0,
     3,     0,     2,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     0,     2,     0,     1,     1,     0,     4,
     0,     2,     0,     1,     1,     0,     2,     0,     3,     0,
     0,     0,     0,     0,     0,     0,    20,     0,     4,     4,
     4,     4,     0,     0,     6,     0,     2,     0,     2,     1,
     1,     1,     0,     0,     6,     0,     0,     5,     0,     4,
     3,     0,     2,     0,     4,     3,     0,     2,     0,     4,
     1,     0,     4,     0,     5,     0,     2,     0,     4,     0,
     4,     0,     4,     0,     4,     0,     4
};

static const short yydefact[] = {     2,
     0,     8,    61,     5,     7,     3,     4,    10,    24,    36,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    13,    23,    22,    21,    20,    19,    18,    17,    16,    15,
    14,    24,     9,     6,    29,    63,    69,    72,    77,    82,
    90,    92,    94,    96,    11,    28,    27,    25,    38,     0,
     0,     0,     0,     0,     0,    37,    31,     0,     0,    71,
    76,    84,    86,     0,     0,     0,     0,     0,    40,    48,
    53,     0,     0,     0,    30,    62,    64,    60,    70,     0,
    73,    81,    78,    86,    83,    91,    93,    95,    97,    39,
     0,    56,     0,     0,     0,     0,    35,    34,    32,    66,
    74,    79,    85,     0,    87,     0,    49,    54,    51,    50,
    52,     0,    65,     0,     0,    88,    41,     0,    57,     0,
     0,    75,    80,     0,     0,    59,    55,    67,    89,     0,
     0,    42,    68,     0,    43,     0,     0,    44,     0,     0,
    45,     0,    46,     0,    47,     0,     0,     0
};

static const short yydefgoto[] = {   146,
     1,     6,    10,     9,    32,     7,    21,    33,    48,    22,
    57,    75,    99,    34,    56,    68,    91,   125,   134,   136,
   139,   142,   144,    92,    93,   120,   107,   119,    79,   104,
    77,    23,    58,   100,   113,   131,    24,    59,    25,    60,
    81,   114,    26,    61,    83,   115,    27,    63,    84,    85,
   105,   124,    28,    64,    29,    65,    30,    66,    31,    67
};

static const short yypact[] = {-32768,
     4,-32768,-32768,-32768,-32768,-32768,    66,-32768,-32768,-32768,
   -28,   -24,   -22,   -11,    -4,    12,    13,    15,    17,    18,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,     3,    11,-32768,-32768,-32768,-32768,-32768,    14,
-32768,-32768,-32768,-32768,     3,-32768,-32768,-32768,-32768,    20,
    21,    23,    24,    25,    26,-32768,-32768,    31,    33,    52,
    52,-32768,-32768,    55,    56,    33,    33,    57,-32768,-32768,
-32768,    52,    52,    52,     7,-32768,-32768,-32768,-32768,    28,
-32768,    34,-32768,-32768,    52,-32768,-32768,-32768,-32768,-32768,
    31,-32768,    31,    35,    36,    37,-32768,-32768,-32768,    38,
-32768,-32768,    52,    46,-32768,    50,    59,-32768,-32768,-32768,
-32768,    76,-32768,    60,    52,-32768,-32768,    58,-32768,    31,
    61,-32768,-32768,    81,    31,-32768,-32768,-32768,-32768,    62,
    31,-32768,-32768,    31,-32768,    31,    64,-32768,    31,    65,
-32768,    31,-32768,    67,-32768,    88,    89,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    68,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -42,    -1,
   -90,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,     8,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768
};


#define	YYLAST		114


static const short yytable[] = {     8,
   106,    35,   108,    -1,     2,    36,    46,    37,     3,    47,
    97,   -12,   -12,    98,   -12,   -12,   -12,   -12,    38,   -12,
   -12,   -12,   -12,    88,    89,    39,     4,     5,    62,   127,
    49,    50,    51,    76,   130,    52,    78,    53,    54,    55,
   133,    40,    41,   135,    42,   137,    43,    44,   140,    69,
    70,   143,    71,    72,    73,    74,     3,   101,    80,    82,
    86,    87,    90,   102,   118,   122,   109,   110,   111,   112,
    94,    95,    96,    11,    12,   116,    13,    14,    15,    16,
   117,    17,    18,    19,    20,   121,   129,   147,   148,   126,
   128,   103,   132,   138,   141,     0,     0,     0,   145,    45,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   123
};

static const short yycheck[] = {     1,
    91,    30,    93,     0,     1,    30,     4,    30,     5,     7,
     4,     8,     9,     7,    11,    12,    13,    14,    30,    16,
    17,    18,    19,    66,    67,    30,    23,    24,    15,   120,
    20,    21,    22,     3,   125,    25,     4,    27,    28,    29,
   131,    30,    30,   134,    30,   136,    30,    30,   139,    30,
    30,   142,    30,    30,    30,    30,     5,    30,    60,    61,
     6,     6,     6,    30,     6,     6,    32,    32,    32,    32,
    72,    73,    74,     8,     9,    30,    11,    12,    13,    14,
    31,    16,    17,    18,    19,    10,     6,     0,     0,    32,
    30,    84,    31,    30,    30,    -1,    -1,    -1,    32,    32,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   115
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison.simple"
/* This file comes from bison-1.26.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 216 "/usr/local/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 5:
#line 85 "parser.yy"
{
										if(gRcsFile != 0L)
										{
											gRcsFile->AllRevs().push_back(CRevFile());
											gRevFile = &gRcsFile->LastRev();
										}
									;
    break;}
case 7:
#line 93 "parser.yy"
{ gRcsFile = 0L; expect(kNone); ;
    break;}
case 8:
#line 94 "parser.yy"
{
										int c = yyvsp[0].aint;
										yyclearin;
										expect(kAnyButSep);
										if(gRevFile != 0L)
											gRevFile->DescLog() << (char)c;
										else if(gRcsFile != 0L)
											gRcsFile->DescLog() << (char)c;
									;
    break;}
case 10:
#line 104 "parser.yy"
{
										expect(kAnyButSep);
										if(gRevFile != 0L)
											gRevFile->DescLog() << sStr;
										else if(gRcsFile != 0L)
											gRcsFile->DescLog() << sStr;
									;
    break;}
case 27:
#line 138 "parser.yy"
{
							char c = yyvsp[0].aint;
							if(gRevFile != 0L)
								gRevFile->DescLog() << c;
							else if(gRcsFile != 0L)
								gRcsFile->DescLog() << c;
						;
    break;}
case 28:
#line 145 "parser.yy"
{
							if(gRevFile != 0L)
								gRevFile->DescLog() << yyvsp[0].string;
							else if(gRcsFile != 0L)
								gRcsFile->DescLog() << yyvsp[0].string;
							free(yyvsp[0].string);
						;
    break;}
case 29:
#line 155 "parser.yy"
{ expect(kAnyButSep); ;
    break;}
case 34:
#line 166 "parser.yy"
{
							char c = yyvsp[0].aint;
							if(gRcsFile != 0L)
								gRcsFile->DescLog() << c;
						;
    break;}
case 35:
#line 171 "parser.yy"
{
							if(gRcsFile != 0L)
								gRcsFile->DescLog() << yyvsp[0].string;
							free(yyvsp[0].string);
						;
    break;}
case 38:
#line 183 "parser.yy"
{ expect(kRevnum); ;
    break;}
case 39:
#line 184 "parser.yy"
{
										if(gRevFile != 0L)
										{
											gRevFile->RevNum() = sRev;
										}
										sRev.reset();
									;
    break;}
case 40:
#line 191 "parser.yy"
{ expect(kDate); ;
    break;}
case 41:
#line 192 "parser.yy"
{
										if(gRevFile != 0L)
										{
											gRevFile->RevTime().tm_year = sInt - 1900;
										}
									;
    break;}
case 42:
#line 198 "parser.yy"
{
										if(gRevFile != 0L)
										{
											gRevFile->RevTime().tm_mon = sInt;
										}
									;
    break;}
case 43:
#line 204 "parser.yy"
{
										if(gRevFile != 0L)
										{
											gRevFile->RevTime().tm_mday = sInt;
										}
									;
    break;}
case 44:
#line 210 "parser.yy"
{
										if(gRevFile != 0L)
										{
											gRevFile->RevTime().tm_hour = sInt;
										}
									;
    break;}
case 45:
#line 216 "parser.yy"
{
										if(gRevFile != 0L)
										{
											gRevFile->RevTime().tm_min = sInt;
										}
									;
    break;}
case 46:
#line 222 "parser.yy"
{
										if(gRevFile != 0L)
										{
											gRevFile->RevTime().tm_sec = sInt;
										}
										expect(kNone);
									;
    break;}
case 48:
#line 230 "parser.yy"
{ expect(kRevnum); ;
    break;}
case 50:
#line 233 "parser.yy"
{
										if(gRevFile != 0L)
										{
											gRevFile->Author() = sStr;
										}
									;
    break;}
case 51:
#line 240 "parser.yy"
{
										if(gRevFile != 0L)
										{
											gRevFile->Locker() = sStr;
										}
									;
    break;}
case 52:
#line 247 "parser.yy"
{
										if(gRevFile != 0L)
										{
											gRevFile->State() = sStr;
										}
									;
    break;}
case 53:
#line 253 "parser.yy"
{ expect(kInt); ;
    break;}
case 54:
#line 254 "parser.yy"
{
										expect(kInt);
										if(gRevFile != 0L)
										{
											gRevFile->ChgPos() = sInt;
										}
									;
    break;}
case 55:
#line 261 "parser.yy"
{
										if(gRevFile != 0L)
										{
											gRevFile->ChgNeg() = sInt;
										}
									;
    break;}
case 59:
#line 276 "parser.yy"
{
									if(gRevFile != 0L)
									{
										gRevFile->BranchesList().push_back(sRev);
									}

									sRev.reset();
									expect(kRevnum);
								;
    break;}
case 60:
#line 288 "parser.yy"
{ sStr = yyvsp[0].string; free(yyvsp[0].string); ;
    break;}
case 61:
#line 292 "parser.yy"
{ sStr = yyvsp[0].string; free(yyvsp[0].string); ;
    break;}
case 62:
#line 296 "parser.yy"
{ sInt = yyvsp[0].aint; ;
    break;}
case 63:
#line 300 "parser.yy"
{ expect(kInt); ;
    break;}
case 64:
#line 301 "parser.yy"
{
										if(gRcsFile != 0L)
										{
											gRcsFile->TotRevisions() = sInt;
										}
									;
    break;}
case 67:
#line 312 "parser.yy"
{ expect(kInt); ;
    break;}
case 68:
#line 313 "parser.yy"
{
										if(gRcsFile != 0L)
										{
											gRcsFile->SelRevisions() = sInt;
										}
									;
    break;}
case 69:
#line 321 "parser.yy"
{ expect(kString); ;
    break;}
case 70:
#line 322 "parser.yy"
{
									if(gRcsFile != 0L)
									{
										gRcsFile->KeywordSubst() = sStr;
									}
								;
    break;}
case 74:
#line 340 "parser.yy"
{
									expect(kRevnum);
									if(gRcsFile != 0L)
									{
										CRevNumber newRev;
										newRev.Tag() = sStr;
										gRcsFile->SymbolicList().push_back(newRev);
									}
								;
    break;}
case 75:
#line 349 "parser.yy"
{
									if(gRcsFile != 0L)
									{
										sRev.Tag() = gRcsFile->LastSymbName().Tag();
										gRcsFile->LastSymbName() = sRev;
									}
									sRev.reset();
								;
    break;}
case 79:
#line 369 "parser.yy"
{
									if(gRcsFile != 0L)
									{
										CLogStr newAccess;
										newAccess = sStr;
										gRcsFile->AccessList().push_back(newAccess);
									}
								;
    break;}
case 81:
#line 378 "parser.yy"
{
									if(gRcsFile != 0L)
									{
										CLogStr newAccess;
										newAccess = sStr;
										gRcsFile->AccessList().push_back(newAccess);
									}
								;
    break;}
case 82:
#line 389 "parser.yy"
{
											if(gRcsFile != 0L)
											{
												gRcsFile->LockStrict() = false;
											}
										;
    break;}
case 84:
#line 396 "parser.yy"
{
											if(gRcsFile != 0L)
											{
												gRcsFile->LockStrict() = true;
											}
										;
    break;}
case 88:
#line 411 "parser.yy"
{
									expect(kRevnum);
									if(gRcsFile != 0L)
									{
										CRevNumber newRev;
										newRev.Tag() = sStr;
										gRcsFile->LocksList().push_back(newRev);
									}
								;
    break;}
case 89:
#line 420 "parser.yy"
{
									if(gRcsFile != 0L)
									{
										sRev.Tag() = gRcsFile->LastLock().Tag();
										gRcsFile->LastLock() = sRev;
									}
									sRev.reset();
								;
    break;}
case 90:
#line 431 "parser.yy"
{ expect(kRevnumOrNil); ;
    break;}
case 91:
#line 432 "parser.yy"
{
								if(gRcsFile != 0L)
								{
									gRcsFile->BranchRev() = sRev;
								}
								sRev.reset();
							;
    break;}
case 92:
#line 442 "parser.yy"
{ expect(kRevnum); ;
    break;}
case 93:
#line 443 "parser.yy"
{
								if(gRcsFile != 0L)
								{
									gRcsFile->HeadRev() = sRev;
								}
								sRev.reset();
							;
    break;}
case 94:
#line 453 "parser.yy"
{ expect(kString); ;
    break;}
case 95:
#line 454 "parser.yy"
{
									if(gRcsFile != 0L)
									{
										gRcsFile->WorkingFile() = sStr;
									}
								;
    break;}
case 96:
#line 463 "parser.yy"
{ expect(kString); ;
    break;}
case 97:
#line 464 "parser.yy"
{
									// push a new rcs file
									gRcsFiles.push_back(CRcsFile());
									gRcsFile = &gRcsFiles[gRcsFiles.size() - 1];
									gRcsFile->RcsFile() = sStr;
								;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 542 "/usr/local/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 471 "parser.yy"


void yyerror(const char */*txt*/, ...)
{
	expect(kAnyButSep);
}

static void expect(kTokens type)
{
	expectToken = type;
}

void yylval_set(const char *txt)
{
	yylval.string = strdup(txt);
}

void yylval_set(int anint)
{
	yylval.aint = anint;
}

void yylval_set(const CRevNumber & rev)
{
	sRev = rev;
}

void yyreset(void)
{
	currentLineNumber = 1;
	sStr = "";
	sInt = 0;
	sRev.reset();
	gRcsFiles.erase(gRcsFiles.begin(), gRcsFiles.end());
	gRcsFile = 0L;
	gRevFile = 0L;
	expect(kNone);
}
